function Fig1

clc
close all
clear all

d = 20;  % Dimension
maxit = 300;
% The variable 'maxit' should be more than 100000 for an accurate figure
tr = 1;  % To generate positive definite matrices with unit trace
for v = 0:50
    l(v+1) = v/50;
    logdet = zeros(1, maxit);
    ELog = zeros(1, maxit);
    gam_k = zeros(1, maxit);
    gam_theta = zeros(1, maxit);
    traceM = zeros(1, maxit);
    for it=1:maxit
        if mod(it,2500) == 1
            fprintf('.');
        end
        M1 = randpdm(d,tr,1);
        M2 = randpdm(d,tr,1);
        
        mat = M2 \ M1;
        eigM = eig(mat);
        logdet(it) = sum(log(eigM));
        ELog(it) = Integral_Method(eigM) ;
        gam_k(it) = (sum(eigM)^2) / (2*sum(eigM.^2));
        gam_theta(it) = (2*sum(eigM.^2)) / (sum(eigM));
        traceM(it) = sum(eigM);
    end
    Aapprox1 = psi(d/2)+log(2*traceM/d);
    Aapprox2 = psi(gam_k) + log(gam_theta);
    Aapprox3 = Aapprox1 * (1-l(v+1)) + Aapprox2 * l(v+1) ;
    MSE(v+1) = mean((ELog-Aapprox3).^2);
end

set(gcf, 'Color', [1 1 1])
plot(l, smooth(MSE, 10, 'moving'),'k','LineWidth', 2,'Marker','o','MarkerSize',4);
set(gca, 'yTick', 0:0.05:0.25)
ylabel('Mean Squared Error')
xlabel('Parameter l')