function Fig2

clc
close all
clear all

I = 3:3:150;
maxit = 5;
% The variable 'maxit' should be more than 100000 for an accurate figure
EigTime = TimeEval(@eig, maxit, 0, I);

maxit = 5;
% The variable 'maxit' should be more than 100000 for an accurate figure
IntTime1 = TimeEval(@Integral_Method, maxit, 1e-13, I);

maxit = 5;
% The variable 'maxit' should be more than 100000 for an accurate figure
IntTime2 = TimeEval(@Integral_Method, maxit, 1e-2, I);

maxit = 5;
% The variable 'maxit' should be more than 5000 for an accurate figure
SeriesTime5000 = TimeEval(@Series_Method, maxit, 5000, I);

maxit = 5;
% The variable 'maxit' should be more than 5000 for an accurate figure
SeriesTime3750 = TimeEval(@Series_Method, maxit, 3750, I);

maxit = 5;
% The variable 'maxit' should be more than 5000 for an accurate figure
SeriesTime2500 = TimeEval(@Series_Method, maxit, 2500, I);

maxit = 5;
% The variable 'maxit' should be more than 5000 for an accurate figure
SeriesTime500 = TimeEval(@Series_Method, maxit, 500, I);

maxit = 5;
% The variable 'maxit' should be more than 1000 for an accurate figure
FastTime = TimeEval(@Fast_Methods, maxit, 3, I);

set(gcf, 'Color', [1 1 1])
set(gcf,'Position',[100 100 1250 450])
subplot(1,2,1)
plot(I,1000*smooth(IntTime1, 12, 'moving'),'b','LineWidth', 2,'Marker','o','MarkerSize',4);
hold on
plot(I,1000*smooth(IntTime2, 12, 'moving'),'g','LineWidth', 2,'Marker','o','MarkerSize',4);
plot(I,1000*smooth(EigTime, 12, 'moving'),'r','LineWidth', 2,'Marker','o','MarkerSize',4);
ylabel('Average Running Time(milliseconds)')
xlabel('Dimension(d)')
Ind = 0:30:150;
axis([0 150 0 21]);
h = legend('Integral Method with Absolute Error Tolerance 1e-13','Integral Method with Absolute Error Tolerance 1e-2','The Computation of Eigenvalues','location','Best');
set(h,'Interpreter','latex')
set(gca, 'XTick', Ind)
set(gca, 'YTick',0:2:21)

subplot(1,2,2)
plot(I,1000*smooth(SeriesTime5000, 12, 'moving'),'r','LineWidth', 2,'Marker','o','MarkerSize',4);
hold on
plot(I,1000*smooth(SeriesTime3750, 12, 'moving'),'y','LineWidth', 2,'Marker','o','MarkerSize',4);
plot(I,1000*smooth(SeriesTime2500, 12, 'moving'),'g','LineWidth', 2,'Marker','o','MarkerSize',4);
plot(I,1000*smooth(SeriesTime500, 12, 'moving'),'b','LineWidth', 2,'Marker','o','MarkerSize',4);
ylabel('Average Running Time (ms)')
xlabel('Dimension (d)')
axis([0 150 0 23]);
h = legend('Series Method with L=5000','Series Method with L=3750','Series Method with L=2500','Series Method with L=500','location','Best');
set(h,'Interpreter','latex')
set(gca, 'XTick', Ind)
set(gca, 'YTick',0:2:22)

Figure2=figure(2);
plot(I,1000*smooth(FastTime, 20, 'moving')','k','LineWidth',2,'Marker','o','MarkerSize',4);
ylabel('Average Running Time(milliseconds)')
xlabel('Dimension(d)')
axis([0 150 0 0.7]);
set(gca, 'XTick', Ind)
set(gca, 'YTick',0:0.1:0.7)