function Fig3

clc
close all
clear all

% The variable 'maxit' should be more than 20000 for an accurate figure
maxit = 200;

tr = 1;  % To generate positive definite matrices with unit trace
v = 1;
b = 8:2:140;
for d = b  % Dimensions
    ELog = zeros(1, maxit);
    gam_k = zeros(1, maxit);
    gam_theta = zeros(1, maxit);
    traceM = zeros(1, maxit);
    for it=1:maxit
        M1 = randpdm(d,tr,1);
        M2 = randpdm(d,tr,1);
        
        mat = M2 \ M1;
        ELog(it) = Integral_Method(mat);
        Aapprox1(it) = Fast_Methods(mat, 1);
        Aapprox2(it) = Fast_Methods(mat, 2);
        Aapprox3(it) = Fast_Methods(mat, 3);
    end
    
    MeanAE(1,v) = mean(ELog-Aapprox1);
    MeanAE(2,v) = mean(ELog-Aapprox2);
    MeanAE(3,v) = mean(ELog-Aapprox3);
    stdAE(1,v) = std((ELog-Aapprox1));
    stdAE(2,v) = std((ELog-Aapprox2));
    stdAE(3,v) = std((ELog-Aapprox3));
    v = v+1;
    d
end


set(gcf, 'Color', [1 1 1])
set(gcf,'Position',[100 100 800 700])

m1 = smooth(MeanAE(1,:), 15, 'moving');
e1 = smooth(stdAE(1,:), 15, 'moving');
m2 = smooth(MeanAE(2,:), 15, 'moving');
e2 = smooth(stdAE(2,:), 15, 'moving');
m3 = smooth(MeanAE(3,:), 15, 'moving');
e3 = smooth(stdAE(3,:), 15, 'moving');
shadedErrorBar(b,m1,e1,'r',1);

hold on
plot(b, m1,'r','LineWidth', 1,'Marker','o','MarkerSize',2.2);
shadedErrorBar(b,m2,e2,'g',1);
plot(b, m2,'g','LineWidth', 1,'Marker','o','MarkerSize',2.2);
shadedErrorBar(b,m3,e3,'b',1);
plot(b, m3,'b','LineWidth', 1,'Marker','o','MarkerSize',2.2);

ylabel('Absolute Error')
xlabel('Dimension(d)')
axis([10 140 -0.7 0.7])
I = 0:20:140;
I(1) = 10;
set(gca, 'XTick', I)
set(gca, 'yTick', -0.7:0.2:0.7)
legend('Error standard deviation of the first method','Error mean of the first method','Error standard deviation of the second method','Error mean of the second method','Error standard deviation of the third method','Error mean of the third method','Location','best');
