function Fig4

clc
close all
clear all

% The variable 'maxit' should be more than 20000 for an accurate figure
maxit = 200;

tr = 1;  % To generate positive definite matrices with unit trace
v = 1;
b = 8:2:140;
for d = b  % Dimensions
    logdet = zeros(1, maxit);
    ELog = zeros(1, maxit);
    Aapprox1 = zeros(1, maxit);
    Aapprox2 = zeros(1, maxit);
    Aapprox3 = zeros(1, maxit);
    for it=1:maxit
        M1 = randpdm(d,tr,1);
        M2 = randpdm(d,tr,1);
        
        mat = M2 \ M1;
        logdet(it) = log(det(mat));
        ELog(it) = Integral_Method(mat);
        Aapprox1(it) = Fast_Methods(mat, 1);
        Aapprox2(it) = Fast_Methods(mat, 2);
        Aapprox3(it) = Fast_Methods(mat, 3);
    end
    kl = -0.5 * logdet + ((d/2) * (ELog - psi(d/2) - log(2)));
    KLapprox1 = -0.5 * logdet + (d/2) * (Aapprox1 - psi(d/2) - log(2));
    KLapprox2 = -0.5 * logdet + (d/2) * (Aapprox2 - psi(d/2) - log(2));
    KLapprox3 = -0.5 * logdet + (d/2) * (Aapprox3 - psi(d/2) - log(2));
    MeanAE(1,v) = mean(abs((kl-KLapprox1)./kl)) * 100;
    MeanAE(2,v) = mean(abs((kl-KLapprox2)./kl)) * 100;
    MeanAE(3,v) = mean(abs((kl-KLapprox3)./kl)) * 100;
    stdAE(1,v) = std(abs((kl-KLapprox1)./kl) * 100);
    stdAE(2,v) = std(abs((kl-KLapprox2)./kl) * 100);
    stdAE(3,v) = std(abs((kl-KLapprox3)./kl) * 100);
    v = v+1;
    d
end

set(gcf, 'Color', [1 1 1])
set(gcf,'Position',[100 100 800 700])

m1 = smooth(MeanAE(1,:), 3, 'moving');
e1 = smooth(stdAE(1,:), 3, 'moving');
m2 = smooth(MeanAE(2,:), 3, 'moving');
e2 = smooth(stdAE(2,:), 3, 'moving');
m3 = smooth(MeanAE(3,:), 3, 'moving');
e3 = smooth(stdAE(3,:), 3, 'moving');
shadedErrorBar(b,m1,e1,'r',1);

hold on
plot(b, m1,'r','LineWidth', 1,'Marker','o','MarkerSize',2.2);
shadedErrorBar(b,m2,e2,'g',1);
plot(b, m2,'g','LineWidth', 1,'Marker','o','MarkerSize',2.2);
shadedErrorBar(b,m3,e3,'b',1);
plot(b, m3,'b','LineWidth', 1,'Marker','o','MarkerSize',2.2);

ylabel('Relative Error(%)')
xlabel('Dimension(d)')
axis([10 140 0 25])
I = 0:20:140;
I(1) = 10;
set(gca, 'XTick', I)
set(gca, 'yTick', [0,5,10,15,20,25])
legend('Error standard deviation of the first method','Error mean of the first method','Error standard deviation of the second method','Error mean of the second method','Error standard deviation of the third method','Error mean of the third method','Location','best');
