function Fig5
clc
close all
clear all

d = 2;  % Dimension
maxl = 1;
minl = 0.02565;
eigM = [minl,(rand(1,(d-2))*(maxl-minl))+minl,maxl];

ELogInt = Integral_Method(eigM);
l = sort(eigM);

qh = d/2;
b = 2 * l(1) * l(d) / (l(1) + l(d));
dv = (b./l);
logc0 = 0.5 * sum( log(dv) );
e = max(abs(1-dv));
c = 1;
L0 = ceil(d*e/(2-2*e));
for L = L0:80
    ELogSeries(c) = abs(ELogInt-1*(elsd(l,L)+psi(d/2)+log(2)));
    Err(c) = exp(gammaln(qh+L)-gammaln(qh+1)-gammaln(L+2)+...
        (L+1)*log(e)-log((1-(qh+L)/L*e)^2) + logc0);
    c = c + 1
end
set(gcf, 'Color', [1 1 1])
Figure1=figure(1);
set(Figure1,'defaulttextinterpreter','latex');
semilogy(L0:80,ELogSeries,'g','LineWidth', 1.5)
hold on
semilogy(L0:80,Err,'g','LineWidth', 1.5,'Marker','o','MarkerSize',1.5,'MarkerEdgeColor','k')

clear ELogSeries Err eigM
d = 2;  % Dimension
maxl = 1;
minl = 0.1111;
eigM = [minl,(rand(1,(d-2))*(maxl-minl))+minl,maxl];

ELogInt = Integral_Method(eigM);
l = sort(eigM);

qh = d/2;
b = 2 * l(1) * l(d) / (l(1) + l(d));
dv = (b./l);
logc0 = 0.5 * sum( log(dv) );
e = max(abs(1-dv));
c = 1;
L0 = ceil(d*e/(2-2*e));
for L = L0:80
    ELogSeries(c) = abs(ELogInt-1*(elsd(l,L)+psi(d/2)+log(2)));
    Err(c) = exp(gammaln(qh+L)-gammaln(qh+1)-gammaln(L+2)+...
        (L+1)*log(e)-log((1-(qh+L)/L*e)^2) + logc0);
    c = c + 1
end
semilogy(L0:80,ELogSeries,'r','LineWidth', 1.5)
semilogy(L0:80,Err,'r','LineWidth', 1.5,'Marker','o','MarkerSize',1.5,'MarkerEdgeColor','k')

clear ELogSeries Err eigM
d = 2;  % Dimension
maxl = 1;
minl = 0.25;
eigM = [minl,(rand(1,(d-2))*(maxl-minl))+minl,maxl];

ELogInt = Integral_Method(eigM);
l = sort(eigM);

qh = d/2;
b = 2 * l(1) * l(d) / (l(1) + l(d));
dv = (b./l);
logc0 = 0.5 * sum( log(dv) );
e = max(abs(1-dv));
c = 1;
L0 = ceil(d*e/(2-2*e));
for L = L0:80
    ELogSeries(c) = log10(abs(ELogInt-1*(elsd(l,L)+psi(d/2)+log(2))));
    Err(c) = exp(gammaln(qh+L)-gammaln(qh+1)-gammaln(L+2)+...
        (L+1)*log(e)-log((1-(qh+L)/L*e)^2) + logc0);
    c = c + 1
end
semilogy(L0:80,10.^smooth(ELogSeries, 5, 'moving'),'LineWidth', 1.5)
semilogy(L0:80,Err,'LineWidth', 1.5,'Marker','o','MarkerSize',1.5,'MarkerEdgeColor','k')

h = legend('Error of $\epsilon = 0.95$','Error bound of $\epsilon = 0.95$','Error of $\epsilon = 0.8$','Error bound of $\epsilon = 0.8$','Error of $\epsilon = 0.6$','Error bound of $\epsilon = 0.6$','location','Best');
set(h,'Interpreter','latex')
set(gca, 'yTick', [10^-20,10^-15,10^-10,10^-5,10^0,10^5,10^10])
set(gca, 'xTick', [0,10,20,30,40,50,60,70,80])
ylabel('Absolute Error')
xlabel('Flops($L$)')
