function Fig6

clc
clear all
close all

d = 3;  % Dimension
maxl = 1;
minl = 1/19;
maxit = 1000;

for jj = 1:maxit
    eigM = [minl,(rand(1,(d-2))*(maxl-minl))+minl,maxl];
    
    ELogInt = Integral_Method(eigM);
    l = sort(eigM);
    
    qh = d/2;
    b = 2 * l(1) * l(d) / (l(1) + l(d));
    dv = (b./l);
    logc0 = 0.5 * sum( log(dv) );
    e = max(abs(1-dv));
    c = 1;
    L0 = ceil(d*e/(2-2*e));
    for L = L0:260
        ELogSeries(jj,c) = log10(abs(ELogInt-1*(elsd(l,L)+psi(d/2)+log(2))));
        Err(jj,c) = log10(exp(gammaln(qh+L)-gammaln(qh+1)-gammaln(L+2)+...
            (L+1)*log(e)-log((1-(qh+L)/L*e)^2) + logc0));
        c = c + 1;
    end
    jj
end
m1 = mean(ELogSeries);
m2 = mean(Err);
e1 = std(ELogSeries);
e2 = std(Err);
bbo = L0:260;

clear ELogSeries Err
d = 20;  % Dimension

for jj = 1:maxit
    eigM = [minl,(rand(1,(d-2))*(maxl-minl))+minl,maxl];
    
    ELogInt = Integral_Method(eigM);
    l = sort(eigM);
    
    qh = d/2;
    b = 2 * l(1) * l(d) / (l(1) + l(d));
    dv = (b./l);
    logc0 = 0.5 * sum( log(dv) );
    e = max(abs(1-dv));
    c = 1;
    L0 = ceil(d*e/(2-2*e));
    for L = L0:260
        ELogSeries(jj,c) = log10(abs(ELogInt-1*(elsd(l,L)+psi(d/2)+log(2))));
        Err(jj,c) = log10(exp(gammaln(qh+L)-gammaln(qh+1)-gammaln(L+2)+...
            (L+1)*log(e)-log((1-(qh+L)/L*e)^2) + logc0));
        c = c + 1;
    end
    jj
end
m11 = mean(ELogSeries);
m22 = mean(Err);
e11 = std(ELogSeries);
e22 = std(Err);
bb = L0:260;

set(gcf, 'Color', [1 1 1])
set(gcf,'Position',[100 100 800 700])
hold on
shadedErrorBar(bb, m22, e22, 'm', 1);
plot(bb,m22,'m','LineWidth', 1)
shadedErrorBar(bb, m11, e11, 'b', 1);
plot(bb,m11,'b','LineWidth', 1)
shadedErrorBar(bbo, m2, e2, 'g', 1);
plot(bbo, m2,'g','LineWidth', 1)
shadedErrorBar(bbo, m1, e1, 'r', 1);
plot(bbo,m1,'r','LineWidth', 1)
box on
axis([0 260 -15 12]);
legend('Error bound standard deviation of d=20','Error bound mean of d=20','Error standard deviation of d=20','Error mean of d=20','Error bound standard deviation of d=3','Error bound mean of d=3','Error standard deviation of d=3','Error mean of d=3','Location','best');
set(gca, 'XTick', 0:50:250)
set(gca, 'yTick', -15:5:10)
ylabel('Absolute Error')
xlabel('Flops(L)')
