function Lo = finde(fm,l)
%% Function for calculating length given error fm
fm = log(fm);
l = sort(l);
q = length(l);
qh = q/2;
b = 2 * l(1) * l(q) / (l(1) + l(q));
dv = (b./l);
logc0 = 0.5 * sum( log(dv) );
e = max(abs(1-dv));
% errp = @(x) gammaln(qh+x)-gammaln(qh+1)-gammaln(x+2)+...
%     (x+1)*log(e)-1*log((1-(qh+x)/x*e))+ logc0;
errp = @(x) gammaln(qh+x)-gammaln(qh+1)-gammaln(x+2)+...
    (x+1)*log(e)-log((1-(qh+x)/x*e)^2)+ logc0 - fm;

x0 = ceil(q/2/(1-e));
option.Display = 'off';
x1 = fsolve(errp,x0,option);

% f0 = errp(x0);
% if f0 <= fm
%     Lo = x0;
%     return;
% end
% x1 = x0 * 2;
% f1 = errp(x1);
% while  f1 >= fm
%     x0 = x1;
%     f0 = f1;
%     x1 = x1*2;
%     f1 = errp(x1);
% end
% 
% iter = 0;
% while (x1-x0) > 0.5
%     iter = iter + 1;
%     if iter > 100
%         break;
%     end
%     xn = ( (fm-f0)*(x1-x0)/(f1-f0) + x0);
%     fn = errp(xn);
%     if fn <= fm
%         x1 = xn;
%         f1 = fn;
%     end
%     if fn > fm
%         x0 = xn;
%         f0 = fn;
%     end
%     if abs(f1-fm) < 1e-6
%         x0 = x1;
%     end
%     if abs(f0-fm) < 1e-6
%         x1 = x0;
%         f1 = f0;
%     end
% end
Lo = ceil(x1);
end